# Soaring

This gem provides a collection of command line tools that simplifies the creation, development and packaging of a soar project for deployment at Hetzner.

## Installation

Install the gem from rubygems as follow:
```bash
  gem install soaring
```

## Creating a new project

Create a repo on github/gitlab, clone locally and enter project folder:
```bash
  git clone git@github.com:hetznerZA/my-awesome-service-component.git
  cd my-awesome-service-component
```

Create the fresh project skeleton:
```bash
  soaring init
```

Switch to the appropriate ruby version and install the gem dependencies:
```bash
  rvm use . && bundle install
```

Create an environment.yml file by copying the example and updating to your needs:
```bash
  cp config/environment.yml.example config/environment.yml
```

## Running a service component locally

Start up a local instance of the service component to check that all is well
```bash
  soaring start
```

This will default to a MRI ruby rack application running with the following defaults:
```bash
  port = 9393
  environment = 'development'
```

To stop you can simply send a CTRL-C or programmatically kill it using the stop command from another terminal
```bash
  soaring stop
```

These defaults can be overriden using parameters passed to soaring. View the command line options:
```bash
  soaring help
```

## Packaging the service component for deployment

Make sure your git repo is committed and pushed to master. Execute the following command.
```bash
  soaring package
```

The output build zip file will be placed in the builds folder.

Note that you can specify the --ignore_git_checks flag if you want to skip the git repo validation

## Contributing

Bug reports and feature requests are welcome by email to barney dot de dot villiers at hetzner dot co dot za. This gem is sponsored by Hetzner (Pty) Ltd (http://hetzner.co.za)

## License

The gem is available as open source under the terms of the [MIT License](http://opensource.org/licenses/MIT).
